C     ********************************************************************************
C
C     subroutine Local_Rain
C     Computation of the local rain
C
C     ********************************************************************************

      subroutine Local_rain(I,J,chkPL,Utempo,PasPio,Pl,STpn,INVpn)

      implicit none

      include 'dimarrays.inc'
      include 'comread.inc'
      include 'comrainrun.inc'

      integer I,J,K,indi,chkPL,PasPio,STpn(Nrow,Ncol)
      real Pl,Utempo,INVpn(Nrow*Nraing,Ncol)


      Pl=0.   ! local rainfall [mm]
      if (risp2.EQ.1) then
C        spatial interpolation of the rainfall with the Thiessen method
         if (chkPL.EQ.1) then
C           rainfall data is missing for the current time step: one uses the distribution of the
C           raingauges computed in the NewThiessen subroutine
            Pl=PIO(PasPio,STpn(I,J))*Utempo
         else
C           no missing rainfall data for the current time step: one uses the distribution of the
C           raingauges computed in the Thiessen subroutine
            Pl=PIO(PasPio,STp(I,J))*Utempo                                              
         end if
      else
C        spatial interpolation of the rainfall with the inverse distance method
         if (chkPL.EQ.1) then
            do K=1,Nplu
               indi=I+(K-1)*idim
               Pl=Pl+PIO(PasPio,K)*INVpn(indi,J)*Utempo
            end do
         else
            do K=1,Nplu
               indi=I+(K-1)*idim
               Pl=Pl+PIO(PasPio,K)*INVp(indi,J)*Utempo
            end do
         end if
      end if

      return
      end